/*
 *  TOPPERS Software
 *      Toyohashi Open Platform for Embedded Real-Time Systems
 * 
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2004-2011 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 * 
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 * 
 *  @(#) $Id: target_sil.h 881 2011-12-31 14:06:52Z ertl-honda $
 */

/*
 *  sil.hΥåװ¸AT91SKYEYEѡ
 *
 *  Υ󥯥롼ɥեϡsil.hƬǥ󥯥롼ɤ롥¾Υե
 *  뤫ľܥ󥯥롼ɤ뤳ȤϤʤΥե򥤥󥯥롼
 *  ɤˡt_stddef.h󥯥롼ɤΤǡ˰¸Ƥ
 *  褤
 */

#ifndef TOPPERS_TARGET_SIL_H
#define TOPPERS_TARGET_SIL_H

/*
 *  åפΥǥ
 */
#define SIL_ENDIAN_LITTLE             /* ȥ륨ǥ */

/*
 *  ARMǶ̤
 */
#include "core_sil.h"

#ifndef TOPPERS_MACRO_ONLY

/*
 *  ץåIDϡɥΥɥ쥹
 */
#define TOPPERS_PRC_ID_ADDR 0xFFFFFFE0

/*
 *  ץåIDμ
 */
Inline void
sil_get_pid(ID *p_prcid)
{
	/*
	 * Ŭͭˤ뤿ᡤsilǤϸƤӽФƤʤ
	 */
	*p_prcid = (*((uint32_t *)TOPPERS_PRC_ID_ADDR) + 1); 
}

/*
 *  ƥ।󥿥ե쥤䡼ǻѤ Mutex  ID
 */
#define TOPPERS_SIL_LOC_MUTEX_ID  10

/*
 *  Mutexѥϡɥ
 */
#define TOPPERS_MUTEX_ID_REG      (0xFFFFFF00)
#define TOPPERS_MUTEX_CNT_REG     (0xFFFFFF04)

/*
 *  SIL_LOC_SPN()ץåδtarget_config.c
 */
extern uint32_t TOPPERS_spn_var;

/*
 *  ԥåμsilѤǤʤΤľܥ
 */
Inline uint32_t
TOPPERS_sil_loc_spn(void)
{
	uint32_t irq_fiq_mask;
	ID       prcid;

  retry:
	/* ߥå֤*/
	irq_fiq_mask = TOPPERS_disint();

	/* ԥåμ */
	*((volatile unsigned int *)TOPPERS_MUTEX_ID_REG) = TOPPERS_SIL_LOC_MUTEX_ID;

	if (*((volatile unsigned int *)TOPPERS_MUTEX_CNT_REG) != 1) {
		/* ԥåǤʤä */
		/* ߥå֤ξ֤ */
		TOPPERS_set_fiq_irq(irq_fiq_mask);
		goto retry;
	}

	ARM_MEMORY_CHANGED;

	sil_get_pid(&prcid);
	TOPPERS_spn_var = prcid;

	return irq_fiq_mask;
}

/*
 *  ԥåֵ
 */
Inline void
TOPPERS_sil_unl_spn(uint32_t irq_fiq_mask)
{
	TOPPERS_spn_var = 0;

	ARM_MEMORY_CHANGED;

	*((volatile unsigned int *)TOPPERS_MUTEX_ID_REG) = TOPPERS_SIL_LOC_MUTEX_ID;
	*((volatile unsigned int *)TOPPERS_MUTEX_CNT_REG) = 1;

	/* ԥåμξ֤ */
	TOPPERS_set_fiq_irq(irq_fiq_mask);
}

/*
 *  ԥåζ
 *  ץåԥåƤ˲롥 
 */
Inline void
TOPPERS_sil_force_unl_spn(void)
{
	ID       prcid;

	sil_get_pid(&prcid);
	if (TOPPERS_spn_var == prcid) {
		*((volatile unsigned int *)TOPPERS_MUTEX_ID_REG) = TOPPERS_SIL_LOC_MUTEX_ID;
		*((volatile unsigned int *)TOPPERS_MUTEX_CNT_REG) = 1;
	}
}

/*
 *  ԥå
 */
#define SIL_LOC_SPN() ((void)(TOPPERS_irq_fiq_mask = TOPPERS_sil_loc_spn()))
#define SIL_UNL_SPN() (TOPPERS_sil_unl_spn(TOPPERS_irq_fiq_mask))

#endif /* TOPPERS_MACRO_ONLY */

#endif /* TOPPERS_TARGET_SIL_H */
